<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import { CTA as CallToAction, Faq } from '~/components/common/index.vue';
import { FreeTrialPlans } from '~/components/free-trial/index.vue';
import { getPageMetadata } from '~/common/meta';
import { PageDTO } from '~/models/page.dto';

// This page is continously localized
// Content lives in Contentful

export default Vue.extend({
  name: 'FreeTrial',
  components: {
    FreeTrialPlans,
    Faq,
    CallToAction,
  },
  async asyncData({ $freeTrialService, i18n }: any) {
    try {
      // We pass TRUE as second argument because this is an index slug
      const doc: PageDTO = await $freeTrialService.getContent(
        `free-trial`,
        i18n,
      );

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      hosted: this.$route.query.hosted || 'sass',
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  methods: {
    updateSharedData(newData) {
      this.hosted = newData;
    },
  },
});
</script>

<template>
  <SlpContainer>
    <component
      :is="component.name"
      v-for="component in doc?.components"
      v-show="component.name !== 'call-to-action' || component.key === hosted"
      :key="component.key || component.name"
      :data="component.data"
      @update-data="updateSharedData"
    />
  </SlpContainer>
</template>
